<template>
    <div>
        <div class="spellcard columns" v-if="!!spell">
            <div class="card face column scroll-texture-0">
                <div class="card-header">
                    <div class="flagpole">
                        <div class="fas fa-bookmark spell-class-rank"
                             v-for="classRank in spell.classRanks" :key="classRank.id"
                             v-bind:style="{color: classColors.get(classRank.playClass)}">
                            <span>{{classRank.rank}}</span>
                        </div>
                    </div>
                </div>
                <div class="card-header">
                    <p class="card-header-title">
                        {{spell.name}}
                    </p>
                    <div class="spell-meta">{{spell.id}}</div>
                </div>
                <div class="spell-params">
                    <div v-for="spellParam in Object.keys(spell.parameters)" :key="spellParam">
                        <b>{{spellParam}}</b>: {{spell.parameters[spellParam]}}<br>
                    </div>
                </div>
            </div><!--    -->
            <div class="card back column scroll-texture-0">
                <div class="spell-description">
                    <div class="content">
                        {{spell.description}}
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: "Card",
        props: {
            spell: {
                type: Object
            }
        },
        data() {
            return {
                id: null,
                classColors: new Map([
                    ["PRIEST", "#cccccc"],
                    ["BARD", "#0003a8"],
                    ["BARBARIAN", "#940000"],
                    ["WARRIOR", "#734900"],
                    ["WIZARD", "#00bfe6"],
                    ["DRUID", "#f58f00"],
                    ["MONK", "#00f5bc"],
                    ["PALADIN", "#fa89eb"],
                    ["ROUGE", "#dec400"],
                    ["RANGER", "#008f00"],
                    ["SORCERER", "#5d00a8"],
                    ["DEFAULT", "#000000"]
                ])
            }
        }
    }
</script>

<style>
    .spellcard {
        /*14cm x 72 dpi*/
        width: 420px;
        /*10cm x 72 dpi*/
        height: 300px;
        text-align: left;
    }

    .card {
        box-shadow: unset;
        border: black 1px solid;
        border-radius: 4%;
        position: relative;
        display: inline-block;
        vertical-align: top;
    }

    .spellcard.columns {
        margin: 0;
        display: flex;
    }

    .spellcard.columns:not(:last-child) {
        margin-bottom: 0;
    }

    .spellcard.columns:last-child {
        margin-bottom: 0;
    }

    .face {
        width: 210px;
        /*10cm x 72 dpi*/
        height: 300px;
    }

    .back {
        width: 210px;
        /*10cm x 72 dpi*/
        height: 300px;
    }

    .spell-class-rank {
        color: black;
        font-size: 20pt;
    }

    .card-header {
        display: block;
        width: 100%;
        justify-content: space-around;
        position: relative;
    }

    #app .card-header-title {
        padding: 0.25rem;
        padding-top: 0.33rem;
        width: 100%;
    }

    .spell-meta {
        font-size: 6pt;
        color: #9c9c9c;
        height: fit-content;
        position: absolute;
        top: 0;
        right: 0;
    }

    .fas {
        position: relative;
    }

    .fas span {
        position: absolute;
        top: 3px;
        left: 50%;
        transform: translateX(-50%);
        color: white;
        font-size: 10pt;
        font-family: Arial;
    }

    .flagpole {
        margin-left: 2%;
        margin-right: 2%;
        border-top: #7d4d1e 2px solid;
        border-radius: 2px;
        font-size: 3px;
    }

    .card:after {
        top: 7px;
        left: 7px;
        position: absolute;
        content: "";
        display: block;
        border: black 1px solid;
        border-radius: 50%;
        height: 20px;
        width: 20px;
        background: white;
    }

    .card.face:after {
        left: unset;
        right: 7px;
    }

    .spell-params {
        padding: 5px;
        font-size: 11px;
    }

    .spell-description {
        padding: 5px;
        margin-top: 25px;
        font-size: 11px;
    }

    .scroll-texture-0 {
        background-image: url(../../assets/card/texture/scroll-texture-0.jpg);
        background-repeat: repeat;
    }

    /*
        TODO: make choosable background
     */
    .scroll-texture-1 {
        background-image: url(../../assets/card/texture/scroll-texture-1.jpg);
        background-repeat: repeat;
    }
</style>